CameraControls = {}
-- A Camera like structure
CameraControls.new = function()
  local obj = {}

  local winWidth, winHeight = love.graphics.getDimensions()

  obj.moveCenter = function(x, y)
    love.graphics.translate(x+math.floor(winWidth/2), y+math.floor(winHeight/2))
  end

  obj.move = function(x, y)
    love.graphics.translate(x, y)
  end

  obj.reset = function()
    love.graphics.origin()
  end

  return obj
end

-- Init Global Vars
Canvas = love.graphics.newCanvas()
Camera = CameraControls.new()

function love.load()
  --Basic Player Struc
  Player = {
    x = 0,
    y = 0,
  }


end

function love.update(dt)

  --Basic Player Movement

  if love.keyboard.isDown("d") then
    Player["x"] = Player["x"] + 1
  end
  if love.keyboard.isDown("a") then
    Player["x"] = Player["x"] - 1
  end
  if love.keyboard.isDown("s") then
    Player["y"] = Player["y"] + 1
  end
  if love.keyboard.isDown("w") then
    Player["y"] = Player["y"] - 1
  end

end

function love.draw()
  --Set Canvas
  love.graphics.setCanvas(Canvas)
    Canvas:clear()
    love.graphics.setColor(255, 0, 0)
    --This is a background rect so you can see were the canvas is being drawn
    love.graphics.rectangle("fill", 0, 0, 1000, 1000)
    --Reset color for drawing the "Player" square
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.rectangle("fill", Player["x"], Player["y"], 100, 100)
    Camera.moveCenter(-Player["x"], -Player["y"])
  love.graphics.setCanvas()
  --Draw the canvas at 0,0
  love.graphics.draw(Canvas, 0, 0)
  --Set Background of the screen
  love.graphics.setBackgroundColor(0, 255, 0)
end
